#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define REFINE 2.

int main(int argc,char**argv) {
   FILE *f;
   long lf[1000][3];
   int i,N,filt;
   double DIV,MMIN,MMAX,AVG[1000][2][2];
   double x,c1,d1,c2,d2;

   if (argc!=6) {
      printf("Usage: %s <artstars> <filter> <min mag> <max mag> <bins/mag>\n",*argv);
      exit(0);
   }
   if ((f=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[1]);
      exit(0);
   }
   filt=atoi(argv[2]);
   if (filt!=1 && filt!=2) {
      printf("Must select either filter 1 or 2\n");
      exit(0);
   }
   MMIN=atof(argv[3]);
   MMAX=atof(argv[4]);
   DIV=atof(argv[5]);
   N=(int)((MMAX-MMIN)*DIV+.5);
   if (N<=0) exit(0);
   for (i=0;i<N;i++) AVG[i][0][0]=AVG[i][0][1]=AVG[i][1][0]=AVG[i][1][1]=lf[i][0]=lf[i][1]=lf[i][2]=0;
   fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   while (!feof(f)) {
      if (filt==1) x=c1;
      else x=c2;
      i=(int)((x-MMIN)*DIV);
      if (filt==1) x=d1;
      else x=d2;
      if (i>=0 && i<N) {
	 lf[i][0]++;
	 if (x<50) {
	    lf[i][1]++;
	    AVG[i][0][0]+=x;
	 }
      }
      fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   }
   fclose(f);
   for (i=0;i<N;i++) if (lf[i][1]) AVG[i][0][0]/=lf[i][1];
   if ((f=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[1]);
      exit(0);
   }
   fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   while (!feof(f)) {
      if (filt==1) x=c1;
      else x=c2;
      i=(int)((x-MMIN)*DIV);
      if (filt==1) x=d1;
      else x=d2;
      if (i>=0 && i<N && x<50) AVG[i][0][1]+=(x-AVG[i][0][0])*(x-AVG[i][0][0]);
      fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   }
   fclose(f);
   for (i=0;i<N;i++) if (lf[i][1]>1) AVG[i][0][1]=sqrt(AVG[i][0][1]/(lf[i][1]-1));
   if ((f=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[1]);
      exit(0);
   }
   fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   while (!feof(f)) {
      if (filt==1) x=c1;
      else x=c2;
      i=(int)((x-MMIN)*DIV);
      if (filt==1) x=d1;
      else x=d2;
      if (i>=0 && i<N && x<50 && fabs(x-AVG[i][0][0])<AVG[i][0][1]*REFINE) {
	 lf[i][2]++;
	 AVG[i][1][0]+=x;
      }
      fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   }
   fclose(f);
   for (i=0;i<N;i++) if (lf[i][2]) AVG[i][1][0]/=lf[i][2];
   if ((f=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[1]);
      exit(0);
   }
   fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   while (!feof(f)) {
      if (filt==1) x=c1;
      else x=c2;
      i=(int)((x-MMIN)*DIV);
      if (filt==1) x=d1;
      else x=d2;
      if (i>=0 && i<N && x<50 && fabs(x-AVG[i][0][0])<AVG[i][0][1]*REFINE) AVG[i][1][1]+=(x-AVG[i][1][0])*(x-AVG[i][1][0]);
      fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   }
   fclose(f);
   for (i=0;i<N;i++) if (lf[i][2]>1) AVG[i][1][1]=sqrt(AVG[i][1][1]/(lf[i][2]-1));
   for (i=0;i<N;i++) printf("%5.2f %5.2f %5ld %5ld %7.5f   %7.4f %7.4f\n",MMIN+i/DIV,MMIN+(i+1)/DIV,lf[i][0],lf[i][1],(lf[i][0])?(double)lf[i][1]/lf[i][0]:0,AVG[i][1][0],AVG[i][1][1]);
   return 0;
}
