#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef LINUX
#include "linux.h"
#else
#include "sun.h"
#endif

int X,Y,Z,DMAX,DMIN;
double EXP,GAIN,RN;
float data[4][800][800];

int ferr(FILE *f,char *str) {
   printf("%s\n",str);
   fclose(f);
   return 1;
}

int main(int argc,char**argv) {
   FILE *f;
   char str[82];
   int MODE=0,BMODE=0,line=0,tmp,N,i,j,k,HPP=0;

   if (argc!=4) {
      printf("Usage: %s <filename> <output> <image #>\n",*argv);
      return 1;
   }
   N=atoi(argv[3]);
   if ((N<0) && (N>3)) {
      printf("Image number must be between 0 and 3\n");
      return 1;
   }
   if ((f=fopen(argv[1],"rb"))==NULL) {
      printf("File not found\n");
      return 1;
   }
   while ((!feof(f)) && ((!MODE) || (line%36))) {
      fgets(str,81,f);
      line++;
      if (!MODE) {
	 if (!strncmp(str,"END     ",8)) MODE=1;
	 else if ((!strncmp(str,"SIMPLE  =",9)) && (str[29]!='T')) return ferr(f,"Illegal format type");
	 else if (!strncmp(str,"BITPIX  =",9)) {
	    if (!strncmp(str+27,"-32",3)) BMODE=0;
	    else if (!strncmp(str+27," 32",3)) BMODE=1;
	    else return ferr(f,"Illegal bits per pixel");
	 }
	 else if ((!strncmp(str,"NAXIS   =",9)) && (strncmp(str+27,"  3",3))) return ferr(f,"Illegal number of axes");
	 else if (!strncmp(str,"NAXIS",5)) {
	    tmp=atoi(str+9);
	    if (str[5]=='1') X=tmp;
	    else if (str[5]=='2') Y=tmp;
	    else if (str[5]=='3') Z=tmp;
	 }
	 else if (!strncmp(str,"ATODGAIN=",9)) GAIN=atof(str+9);
	 else if (!strncmp(str,"EXPTIME =",9)) EXP=atof(str+9);
	 else if (!strncmp(str,"RSDPFILL=",9)) DMIN=atoi(str+9);
	 else if (!strncmp(str,"SATURATE=",9)) DMAX=atoi(str+9);
	 else if (!strncmp(str,"HSTPHOT =",9)) HPP=1;
      }
   }
   if (!HPP) return ferr(f,"Not pre-processed by mask");
   if ((X!=800) || (Y!=800) || (Z!=4)) return ferr(f,"Illegal axis size");
   ffread(data,800*800*4,4,f);
   fclose(f);
   if (BMODE) for (i=0;i<4;i++) for (j=0;j<800;j++) for (k=0;k<800;k++) {
      long ii;
      memcpy(&ii,data[i][j]+k,4);
      data[i][j][k]=ii;
   }
   if ((f=fopen(argv[2],"wb"))==NULL) {
      printf("Error on output file\n");
      return 1;
   }
   fputs("SIMPLE  =                    T / Standard FITS format                           ",f);
   fputs("BITPIX  =                  -32 / 32 bit IEEE floating point numbers             ",f);
   fputs("NAXIS   =                    2 / Number of axes                                 ",f);
   fputs("NAXIS1  =                  800 /                                                ",f);
   fputs("NAXIS2  =                  800 /                                                ",f);
   fputs("EXTEND  =                    T / There may be standard extensions               ",f);
   fputs("END                                                                             ",f);
   for (line=7;line<36;line++) fputs("                                                                                ",f);
   ffwrite(data[N],800*800,4,f);
   fclose(f);
   return 0;
}
