#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>
#include "filters.h"

#define Crit 1.5
typedef int nreftype[900][900];
typedef int* reftype[900][900];
int filt[NFILTERS],NN=0;

void findfiles(char *base) {
   int i;
   char fn[41];

   for (i=0;i<NFILTERS;i++) {
      sprintf(fn,"%s.%s",base,filters[i].suffix);
      if (!access(fn,F_OK)) {
	 filt[NN++]=i;
	 printf("Found %s photometry\n",filters[i].name);
      }
   }
   if (NN<2) {
      printf("Not enough filters found\n");
      exit(0);
   }
}

int main(int argc,char**argv) {
   FILE *f;
   double **data,**ddata,**x,**y,Chi,SN,Shmin,Shmax,cp,mag0[NFILTERS],mag[NFILTERS],dmag[NFILTERS];
   float r,BestR;
   int *n,**mark,**type,fld,i,j,k,*Best,TBest,II,JJ,xform;
   int x0,x1,y0,y1,xx,yy,q,Nmatch=0;
   char str[161];
   nreftype *nref;
   reftype *ref;

   if (argc!=7) {
      printf("usage: %s <base> <chi> <S/N> <min sharp> <max sharp> <transform>\n",argv[0]);
      return 1;
   }
   Chi=atof(argv[2]);
   SN=atof(argv[3]);
   Shmin=atof(argv[4]);
   Shmax=atof(argv[5]);
   if (atoi(argv[6])) xform=1;
   else xform=0;
   initfilters();
   findfiles(argv[1]);
   x=(double**)calloc(sizeof(double*),NN);
   y=(double**)calloc(sizeof(double*),NN);
   data=(double**)calloc(sizeof(double*),NN);
   ddata=(double**)calloc(sizeof(double*),NN);
   type=(int**)calloc(sizeof(int*),NN);
   n=(int*)calloc(sizeof(int),NN);
   nref=(nreftype*)calloc(sizeof(nreftype),NN);
   ref=(reftype*)calloc(sizeof(reftype),NN);
   mark=(int**)calloc(sizeof(int*),NN);
   Best=(int*)calloc(sizeof(int),NN);
   if (data==NULL || ddata==NULL || type==NULL || x==NULL || y==NULL || n==NULL || nref==NULL || ref==NULL || mark==NULL || Best==NULL) {
      printf("Memory error\n");
   }
   for (fld=0;fld<4;fld++) {
      for (i=0;i<NN;i++) {
	 sprintf(str,"%s.%s",argv[1],filters[filt[i]].suffix);
	 f=fopen(str,"r");
	 if (f==NULL) {
	    printf("Could not open input file %s\n",str);
	    return 1;
	 }
	 n[i]=0;
	 fgets(str,160,f);
	 while (!feof(f)) {
	    if (atoi(str)==fld && atof(str+46)<=Chi && atof(str+55)>=SN && atof(str+63)>=Shmin && atof(str+63)<=Shmax && atoi(str+70)<4) {
	       n[i]++;
	       j=atoi(str+2)+50;
	       k=atoi(str+9)+50;
	       if (j>=0 && k>=0 && j<900 && k<900) nref[i][j][k]++;
	    }
	    fgets(str,160,f);
	 }
	 fclose(f);
	 for (j=0;j<900;j++) for (k=0;k<900;k++) if (nref[i][j][k]) {
	    ref[i][j][k]=(int*)calloc(sizeof(int),nref[i][j][k]);
	    nref[i][j][k]=0;
	 }
	 data[i]=(double*)calloc(sizeof(double),n[i]+1);
	 ddata[i]=(double*)calloc(sizeof(double),n[i]+1);
	 type[i]=(int*)calloc(sizeof(int),n[i]+1);
	 x[i]=(double*)calloc(sizeof(double),n[i]+1);
	 y[i]=(double*)calloc(sizeof(double),n[i]+1);
	 mark[i]=(int*)calloc(sizeof(int),n[i]+1);
	 if (data[i]==NULL || ddata[i]==NULL || type[i]==NULL || x[i]==NULL || y[i]==NULL || mark[i]==NULL) {
	    printf("Memory error\n");
	    return 1;
	 }
	 sprintf(str,"%s.%s",argv[1],filters[filt[i]].suffix);
	 f=fopen(str,"r");
	 fgets(str,160,f);
	 j=0;
	 n[i]=0;
	 while (!feof(f)) {
	    if (atoi(str)==fld && atof(str+46)<=Chi && atof(str+55)>=SN && atof(str+63)>=Shmin && atof(str+63)<=Shmax && atoi(str+70)<4) {
	       x[i][j]=atof(str+2)+50;
	       y[i][j]=atof(str+9)+50;
	       if (x[i][j]>=0 && y[i][j]>=0 && x[i][j]<900 && y[i][j]<900) {
		  data[i][j]=atof(str+32);
		  ddata[i][j]=atof(str+39);
		  type[i][j]=atoi(str+70);
		  mark[i][j]=0;
		  ref[i][(int)x[i][j]][(int)y[i][j]][nref[i][(int)x[i][j]][(int)y[i][j]]]=j;
		  nref[i][(int)x[i][j]][(int)y[i][j]]++;
		  n[i]++;
		  j++;
	       }
	    }
	    fgets(str,160,f);
	 }
	 fclose(f);
      }
      sprintf(str,"%s.phot",argv[1]);
      if (!fld) f=fopen(str,"w");
      else f=fopen(str,"a");
      if (f==NULL) {
	 printf("Could not open output file %s\n",str);
	 return 1;
      }
      if (!fld) {
	 fprintf(f,"%d filters:\n",NN);
	 for (i=0;i<NN;i++) fprintf(f,"%s\n",filters[filt[i]].name);
      }
      for (II=0;II<=NN-2;II++) for (i=0;i<n[II];i++) if (!mark[II][i] && x[II][i]>=0 && y[II][i]>=0 && x[II][i]<900 && y[II][i]<900) {
	 for (JJ=0;JJ<NN;JJ++) Best[JJ]=-1;
	 Best[II]=i;
	 TBest=1;
	 x0=(int)(x[II][i]-Crit);
	 if (x0<0) x0=0;
	 x1=(int)(x[II][i]+Crit+.99);
	 if (x1>899) x1=899;
	 y0=(int)(y[II][i]-Crit);
	 if (y0<0) y0=0;
	 y1=(int)(y[II][i]+Crit+.99);
	 if (y1>899) y1=899;
	 for (JJ=1+II;JJ<NN;JJ++) {
	    BestR=Crit*Crit;
	    for (xx=x0;xx<=x1;xx++) for (yy=y0;yy<=y1;yy++) for (j=0;j<nref[JJ][xx][yy];j++) if (!mark[JJ][q=ref[JJ][xx][yy][j]]) {
	       if ((fabs(x[II][i]-x[JJ][q])<=Crit) && (fabs(y[II][i]-y[JJ][q])<=Crit)) {
		  r=(x[II][i]-x[JJ][q])*(x[II][i]-x[JJ][q])+(y[II][i]-y[JJ][q])*(y[II][i]-y[JJ][q]);
		  if (r<BestR) {
		     Best[JJ]=q;
		     BestR=r;
		  }
	       }
	    }
	    if (Best[JJ]>=0) TBest++;
	 }
         if (TBest>=2) {
	    cp=0;
	    for (j=0;j<NN;j++) if (Best[j]>=0) cp+=x[j][Best[j]];
	    fprintf(f,"%d %6.2f ",fld,cp/TBest-50);
	    cp=0;
	    for (j=0;j<NN;j++) if (Best[j]>=0) cp+=y[j][Best[j]];
	    fprintf(f,"%6.2f ",cp/TBest-50);
	    cp=0;
	    for (j=0;j<NFILTERS;j++) {
	       mag[j]=mag0[j]=99.999;
	       dmag[j]=0.;
	    }
	    for (j=0;j<NN;j++) if (Best[j]>=0) {
	       mag[filt[j]]=mag0[filt[j]]=data[j][Best[j]];
	       dmag[filt[j]]=ddata[j][Best[j]];
	       if (type[j][Best[j]]>cp) cp=type[j][Best[j]];
	    }
	    if (xform) transform(mag0,dmag,mag);
	    for (j=0;j<NN;j++) fprintf(f,"%6.3f %6.3f ",mag[filt[j]],dmag[filt[j]]);
	    fprintf(f,"%d\n",(int)(cp+.5));
	    Nmatch++;
	    for (j=II;j<NN;j++) if (Best[j]>=0) mark[j][Best[j]]=1;
	 }
      }
      fclose(f);
      for (i=0;i<NN;i++) {
	 free(data[i]);
	 free(type[i]);
	 free(x[i]);
	 free(y[i]);
	 free(mark[i]);
      }
   }
   printf("%d stars matched\n",Nmatch);
   return 0;
}
