#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef LINUX
#include "linux.h"
#else
#include "sun.h"
#endif

void ferr(char *str,int x) {
   printf("Error in %s keyword; value should be %d\n",str,x);
   exit(0);
}

int main(int argc,char**argv) {
   int PSIZE=0,ct=0,i;
   char str[90];
   float data[800][800],x[10000];
   FILE *f,*fout;

   if (argc!=3) {
      printf("Usage: %s <base> <output>\n",*argv);
      exit(0);
   }
   sprintf(str,"%sh",argv[1]);
   if ((f=fopen(str,"rb"))==NULL) {
      printf("Could not open \"%s\"\n",str);
      exit(0);
   }
   if ((fout=fopen(argv[2],"wb"))==NULL) {
      printf("Could not open \"%s\"\n",argv[2]);
      exit(0);
   }
   fgets(str,90,f);
   while (!feof(f)) {
      if (!strncmp(str,"PSIZE   =",9)) {
	 PSIZE=atoi(str+9);
	 str[0]=0;
      }
      else if (!strncmp(str,"SIMPLE  =",9)) sprintf(str,"SIMPLE  =                    T / Standard FITS format                           ");
      else if (!strncmp(str,"BITPIX  =",9)) {
	 if (atoi(str+9)!=32) ferr("BITPIX",32);
	 sprintf(str,"BITPIX  =                  -32 / 32 bit IEEE floating point numbers             ");
      }
      else if (!strncmp(str,"NAXIS   =",9)) {
	 if (atoi(str+9)!=2) ferr("NAXIS",2);
	 sprintf(str,"NAXIS   =                    3 / Number of axes                                 ");
      }
      else if (!strncmp(str,"NAXIS1  =",9)) {
	 if (atoi(str+9)!=800) ferr("NAXIS1",800);
	 str[80]=0;
      }
      else if (!strncmp(str,"NAXIS2  =",9)) {
	 if (atoi(str+9)!=800) ferr("NAXIS1",800);
	 sprintf(str,"NAXIS2  =                  800 /                                                ");
      }
      else if (!strncmp(str,"GCOUNT  =",9)) {
	 if (atoi(str+9)!=4) ferr("GCOUNT",4);
	 sprintf(str,"NAXIS3  =                    4 /                                                ");
      }
      else if (!strncmp(str,"EXTEND  =",9) || !strncmp(str,"ATODGAIN=",9) || !strncmp(str,"RNOISE  =",9) || !strncmp(str,"EXPSTART=",9) || !strncmp(str,"EXPEND  =",9) || !strncmp(str,"EXPTIME =",9) || !strncmp(str,"RSDPFILL=",9) || !strncmp(str,"SATURATE=",9) || !strncmp(str,"UCH1CJTM=",9) || !strncmp(str,"FILTNAM1=",9) || !strncmp(str,"END      ",9)) str[80]=0;
      else str[0]=0;
      if (str[0]) {
	 ct++;
	 fprintf(fout,"%s",str);
      }
      fgets(str,90,f);
   }
   fclose(f);
   sprintf(str,"                                                                                ");
   while (ct%36) {
      fprintf(fout,"%s",str);
      ct++;
   }
   if (PSIZE%8) {
      printf("PSIZE not even number of bytes\n");
      exit(0);
   }
   PSIZE/=8;
   sprintf(str,"%sd",argv[1]);
   if ((f=fopen(str,"rb"))==NULL) {
      printf("Could not open \"%s\"\n",str);
      exit(0);
   }
   for (i=0;i<4;i++) {
      ffread(data,800*800,4,f);
      ffwrite(data,800*800,4,fout);
      ffread(x,PSIZE,1,f);
   }
   for (i=0;i<4;i++) ;
   fclose(f);
   fclose(fout);
   return 0;
}
