#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc,char**argv) {
   FILE *f;
   long lf[1000][3];
   float dlf[1000];
   char str[80];
   int i,N,filt;
   double DIV,MMIN,MMAX;
   double x,c1,d1,c2,d2;

   if (argc!=7) {
      printf("Usage: %s <phot> <artstars> <filter #> <min mag> <max mag> <bins/mag>\n",*argv);
      exit(0);
   }
   filt=atoi(argv[3]);
   if (filt<1 || filt>2) {
      printf("Filter number must be 1 or 2\n");
      exit(0);
   }
   MMIN=atof(argv[4]);
   MMAX=atof(argv[5]);
   DIV=atof(argv[6]);
   N=(int)((MMAX-MMIN)*DIV+.5);
   if (N<=0) exit(0);
   for (i=0;i<N;i++) lf[i][0]=lf[i][1]=lf[i][2]=0;
   for (i=0;i<N;i++) dlf[i]=0;
   if ((f=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[1]);
      exit(0);
   }
   fgets(str,80,f);
   while (!feof(f)) {
      if (atoi(str)+1) {
         i=(int)((atof(str+32)-MMIN)*DIV);
         if (i>=0 && i<N) lf[i][0]++;
      }
      fgets(str,80,f);
   }
   fclose(f);
   if ((f=fopen(argv[2],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[2]);
      exit(0);
   }
   fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   while (!feof(f)) {
      if (filt==1) x=c1;
      else x=c2;
      i=(int)((x-MMIN)*DIV);
      if (filt==1) x=d1;
      else x=d2;
      if (i>=0 && i<N) {
	 lf[i][1]++;
	 if (x<50) {
	    lf[i][2]++;
	    dlf[i]+=x*x;
	 }
      }
      fscanf(f,"%lf %lf %lf %lf %lf %lf %lf",&x,&x,&x,&c1,&d1,&c2,&d2);
   }
   fclose(f);
   printf(" mag0  mag1  Nobs Nfake  Nrec  complt       corrected      sig\n");
   for (i=0;i<N;i++) {
      if (lf[i][2]) {
	 x=(double)lf[i][2]/lf[i][1];
	 dlf[i]=sqrt(dlf[i]/lf[i][2]);
	 printf("%5.2f %5.2f %5ld %5ld %5ld %7.5f %9.3f %8.3f %6.3f\n",MMIN+i/DIV,MMIN+(i+1)/DIV,lf[i][0],lf[i][1],lf[i][2],x,lf[i][0]/x,(lf[i][0])?lf[i][0]/x*sqrt(1./lf[i][0]+1./lf[i][2]):1./x*sqrt(1+1./lf[i][2]),dlf[i]);
      }
      else if (lf[i][1]) {
	 printf("%5.2f %5.2f %5ld %5ld %5ld %7.5f %9.3f %8.3f %6.3f\n",MMIN+i/DIV,MMIN+(i+1)/DIV,lf[i][0],lf[i][1],lf[i][2],0.,-1.,-1.,0.);
      }
      else {
	 printf("%5.2f %5.2f %5ld %5ld %5ld %7.5f %9.3f %8.3f %6.3f\n",MMIN+i/DIV,MMIN+(i+1)/DIV,lf[i][0],lf[i][1],lf[i][2],-1.,-1.,-1.,0.);
      }
   }
   return 0;
}
