#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifdef LINUX
#include "linux.h"
#else
#include "sun.h"
#endif
#include "filters.h"

int main(int argc,char**argv) {
   FILE *f;
   char str[160]="aaaaaa",fn[80];
   int nv,nvi,i,j,ii,jj,k,kk,XX=2,XY=3,fld,F=0,tp=0,SMOOTH=0,filt[2],nf,pfilt[2];
   double v0,dv,vi0,dvi,x,y,Xc=400,Yc=400,R=-1;
   float **map,**map2,minmax[2],X,Y,V,I,q=0.,xx,yy;

   if (argc!=11 && argc!=16) {
      printf("Usage: %s <base> <filt 1> <filt 2> <Mmin> <Mmax> <dM> <Cmin> <Cmax> <dC> <smooth>\n <<f> <xc> <yc> <r> <type>>\n",*argv);
      exit(0);
   }
   if (argc==14) {
      F=atoi(argv[11]);
      Xc=atof(argv[12]);
      Yc=atof(argv[13]);
      R=atof(argv[14]);
      tp=atoi(argv[15]);
   }
   SMOOTH=atoi(argv[10]);
   initfilters();
   for (filt[0]=0;filt[0]<NFILTERS && strcmp(argv[2],filters[filt[0]].suffix);filt[0]++);
   if (filt[0]>=NFILTERS) filt[0]=findfilt(argv[2]);
   for (filt[1]=0;filt[1]<NFILTERS && strcmp(argv[3],filters[filt[1]].suffix);filt[1]++);
   if (filt[1]>=NFILTERS) filt[1]=findfilt(argv[3]);
   v0=atof(argv[4]);
   x=atof(argv[5]);
   dv=atof(argv[6]);
   nv=1+(int)((x-v0)/dv);
   if (nv<1 || dv<=0) {
      printf("Illegal mag options\n");
      exit(0);
   }
   vi0=atof(argv[7]);
   x=atof(argv[8]);
   dvi=atof(argv[9]);
   nvi=1+(int)((x-vi0)/dvi);
   if (nvi<1 || dvi<=0) {
      printf("Illegal color options\n");
      exit(0);
   }
   map=(float**)calloc(nv,sizeof(float*));
   map2=(float**)calloc(nv,sizeof(float*));
   if (map==NULL || !map2) {
      printf("Memory error\n");
      exit(0);
   }
   for (i=0;i<nv;i++) {
      map[i]=(float*)calloc(nvi,sizeof(float));
      map2[i]=(float*)calloc(nvi,sizeof(float));
      if (map[i]==NULL || !map2[i]) {
	 printf("Memory error\n");
	 exit(0);
      }
   }
   sprintf(fn,"%s.phot",argv[1]);
   if ((f=fopen(fn,"r"))==NULL) {
      printf("Cannot open \"%s\"\n",fn);
      exit(0);
   }
   fscanf(f,"%d",&nf);
   fgets(str,81,f);
   pfilt[0]=pfilt[1]=-1;
   for (i=0;i<nf;i++) {
      fgets(str,81,f);
      str[strlen(str)-1]=0;
      if (!strcmp(str,filters[filt[0]].name)) pfilt[0]=i;
      if (!strcmp(str,filters[filt[1]].name)) pfilt[1]=i;
   }
   if (pfilt[0]<0 || pfilt[1]<0) {
      printf("Filter not in %s.phot\n",argv[1]);
      exit(0);
   }
   fscanf(f,"%d %f %f",&fld,&X,&Y);
   while (!feof(f)) {
      V=I=-100;
      for (i=0;i<nf;i++) {
	 fscanf(f,"%f %f",&xx,&yy);
	 if (i==pfilt[0]) V=xx;
	 if (i==pfilt[1]) I=xx;
      }
      fscanf(f,"%d",&i);
      i=(int)((V-v0)/dv);
      if (pfilt[0]<pfilt[1]) j=(int)((V-I-vi0)/dvi);
      else j=(int)((I-V-vi0)/dvi);
      if (i>=0 && j>=0 && i<nv && j<nvi) {
	 if (R<=0 || (fld==F && (X-Xc)*(X-Xc)+(Y-Yc)*(Y-Yc)<=R*R)) {
	    if (tp==0 || tp==2) map[i][j]++;
	 }
	 else {
	    if (tp==1) map[i][j]++;
	    else if (tp==2) map[i][j]-=R*R*3.14/(555025.-R*R*3.14);
	 }
      }
      fscanf(f,"%d %f %f",&fld,&X,&Y);
   }
   fclose(f);
   if (SMOOTH>0) {
      y=1./SMOOTH/SMOOTH;
      for (i=0;i<nv;i++) for (j=0;j<nvi;j++) if (map[i][j]!=0) {
	 x=0;
	 for (ii=-SMOOTH*3;ii<=SMOOTH*3;ii++) for (jj=-SMOOTH*3;jj<=SMOOTH*3;jj++) if (ii+i>=0 && ii+i<nv && jj+j>=0 && jj+j<nvi) x+=exp(-ii*ii*y-jj*jj*y);
	 x=1/x;
	 for (ii=-SMOOTH*3;ii<=SMOOTH*3;ii++) for (jj=-SMOOTH*3;jj<=SMOOTH*3;jj++) if (ii+i>=0 && ii+i<nv && jj+j>=0 && jj+j<nvi) map2[i][j]+=map[i+ii][j+jj]*exp(-ii*ii*y-jj*jj*y)*x;
      }
   }
   else for (i=0;i<nv;i++) for (j=0;j<nvi;j++) map2[i][j]=map[i][j];
   minmax[0]=minmax[1]=map2[0][0];
   for (i=0;i<nv;i++) for (j=0;j<nvi;j++) {
      if (map2[i][j]<minmax[0]) minmax[0]=map2[i][j];
      if (map2[i][j]>minmax[1]) minmax[1]=map2[i][j];
   }
   printf("CMD limits: %f to %f\n",minmax[0],minmax[1]);
   minmax[1]=1/(minmax[1]-minmax[0]);
   for (i=0;i<nv;i++) for (j=0;j<nvi;j++) map2[i][j]=1-sqrt((map2[i][j]-minmax[0])*minmax[1]);
   XX=898/nvi;
   if (XX<1) XX=1;
   XY=898/nv;
   if (XY<1) XY=1;
   sprintf(fn,"%s.phot.fits",argv[1]);
   if ((f=fopen(fn,"wb"))==NULL) {
      printf("Cannot open \"%s\"\n",fn);
      exit(0);
   }
   fputs("SIMPLE  =                    T / Standard FITS format                           ",f);
   fputs("BITPIX  =                  -32 / 32 bit IEEE floating point numbers             ",f);
   fputs("NAXIS   =                    2 / Number of axes                                 ",f);
   sprintf(str,"NAXIS1  =                %5d /                                                ",nvi*XX+2);
   fputs(str,f);
   sprintf(str,"NAXIS2  =                %5d /                                                ",nv*XY+2);
   fputs(str,f);
   fputs("EXTEND  =                    T / There may be standard extensions               ",f);
   fputs("END                                                                             ",f);
   for (i=7;i<36;i++) fputs("                                                                                ",f);
   for (k=0;k<nvi*XX+2;k++) ffwrite(&q,1,4,f);
   for (i=nv-1;i>=0;i--) for (k=0;k<XY;k++) {
      ffwrite(&q,1,4,f);
      for (j=0;j<nvi;j++) for (kk=0;kk<XX;kk++) ffwrite(map2[i]+j,1,4,f);
      ffwrite(&q,1,4,f);
   }
   for (k=0;k<nvi*XX+2;k++) ffwrite(&q,1,4,f);
   fclose(f);
   return 0;
}
