#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define Nmax 50000

int main(int argc,char**argv)

{
   double scale[4]={0.04554,0.09961,0.09958,0.09964};
   FILE *fin,*fout;
   double pos[4][2][Nmax][2],x,y;
   float offset[2]={0,0},doffset[2]={0,0},prev[2],dprev[2],mins;
   int f,i,j,N[4][2],NM,pNM,SAVE=1;
   char str[161];

   if (argc<5 || argc==6 || argc>7) {
      printf("usage: %s <refphot> <phot> <output> <min ct> <<offsetX Y>>\n",argv[0]);
      exit(0);
   }
   if ((fin=fopen(argv[2],"r"))==NULL) SAVE=0;
   else fclose(fin);
   if (SAVE) {
      if ((fout=fopen(argv[3],"w"))==NULL) {
	 printf("%s not writeable\n",argv[3]);
	 SAVE=0;
      }
      else fclose(fout);
   }
   mins=atof(argv[4]);
   if (argc==7) {
      offset[0]=atof(argv[5]);
      offset[1]=atof(argv[6]);
   }
   else offset[0]=offset[1]=0;
   for (f=3;f>=0;f--) scale[f]/=scale[0];
   for (i=0;i<2;i++) {
      for (f=0;f<4;f++) N[f][i]=0;
      if ((fin=fopen(argv[1+i],"r"))==NULL) {
	 printf("%s not found\n",argv[1+i]);
	 exit(0);
      }
      fgets(str,80,fin);
      while (!feof(fin)) {
	 if (atof(str+16)>=mins) {
	    f=atoi(str);
	    x=atof(str+2)*scale[f];
	    y=atof(str+9)*scale[f];
	    switch(f) {
	    case 0:pos[f][i][N[f][i]][0]= x; pos[f][i][N[f][i]][1]= y; break;
	    case 1:pos[f][i][N[f][i]][0]=-y; pos[f][i][N[f][i]][1]= x; break;
	    case 2:pos[f][i][N[f][i]][0]=-x; pos[f][i][N[f][i]][1]=-y; break;
	    case 3:pos[f][i][N[f][i]][0]= y; pos[f][i][N[f][i]][1]=-x; break;
	    }
	    N[f][i]++;
	    if (N[f][i]>Nmax) {
	       printf("Overflow\n");
	       exit(0);
	    }
	 }
	 fgets(str,80,fin);
      }
      fclose(fin);
   }
   if (argc==7) doffset[0]=doffset[1]=2;
   else doffset[0]=doffset[1]=10;
   NM=0;
   do {
      pNM=NM;
      prev[0]=offset[0];
      prev[1]=offset[1];
      offset[0]=offset[1]=0;
      dprev[0]=doffset[0]*1.5;
      if (dprev[0]>25) dprev[0]=25;
      dprev[1]=doffset[1]*1.5;
      if (dprev[1]>25) dprev[1]=25;
      doffset[0]=doffset[1]=0;
      NM=0;
      for (f=0;f<4;f++) for (i=0;i<N[f][0];i++) for (j=0;j<N[f][1];j++) if (fabs(pos[f][0][i][0]+prev[0]-pos[f][1][j][0])<=dprev[0] && fabs(pos[f][0][i][1]+prev[1]-pos[f][1][j][1])<=dprev[1]) {
	 offset[0]+=pos[f][1][j][0]-pos[f][0][i][0];
	 offset[1]+=pos[f][1][j][1]-pos[f][0][i][1];
	 NM++;
      }
      if (!NM) printf("No convergence\n");
      else {
	 offset[0]/=NM;
	 offset[1]/=NM;
	 for (f=0;f<4;f++) for (i=0;i<N[f][0];i++) for (j=0;j<N[f][1];j++) if (fabs(pos[f][0][i][0]+prev[0]-pos[f][1][j][0])<=dprev[0] && fabs(pos[f][0][i][1]+prev[1]-pos[f][1][j][1])<=dprev[1]) {
	    doffset[0]+=(pos[f][1][j][0]-offset[0]-pos[f][0][i][0])*(pos[f][1][j][0]-offset[0]-pos[f][0][i][0]);
	    doffset[1]+=(pos[f][1][j][1]-offset[1]-pos[f][0][i][1])*(pos[f][1][j][1]-offset[1]-pos[f][0][i][1]);
	 }
	 doffset[0]=sqrt(doffset[0]/(NM-1));
	 doffset[1]=sqrt(doffset[1]/(NM-1));
      }
   } while (NM!=pNM);
   if (NM) printf("%d: %f (%f), %f (%f)\n",NM,offset[0],doffset[0]/sqrt(NM),offset[1],doffset[1]/sqrt(NM));
   if (SAVE) {
      if ((fin=fopen(argv[2],"r"))==NULL) {
	 printf("%s not found\n",argv[2]);
	 exit(0);
      }
      if ((fout=fopen(argv[3],"a"))==NULL) {
	 printf("%s not writeable\n",argv[3]);
	 exit(0);
      }
      fscanf(fin,"%d",&i);
      while (!feof(fin)) {
	 double A,B,C,D,E,F,G,H,I,J;
	 fscanf(fin,"%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf",&A,&B,&C,&D,&E,&F,&G,&H,&I,&J);
	 switch(i) {
	 case 0:A-=offset[0]/scale[0]; B-=offset[1]/scale[0]; break;
	 case 1:A-=offset[1]/scale[1]; B+=offset[0]/scale[1]; break;
	 case 2:A+=offset[0]/scale[2]; B+=offset[1]/scale[2]; break;
	 case 3:A+=offset[1]/scale[3]; B-=offset[0]/scale[3]; break;
	 }
	 fprintf(fout,"%d %6.2f %6.2f ",i,A,B);
	 if (C<999999.5) fprintf(fout,"%8.1f",C);
	 else fprintf(fout,"%8.2e",C);
	 fprintf(fout," %6.2f %6.3f %6.3f %8.4f %7.1f %6.3f %d\n",D,E,F,G,H,I,(int)(J+.5));
	 fscanf(fin,"%d",&i);
      }
      fclose(fout);
      fclose(fin);
   }
   return 0;
}
