#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*#define Rmin 1.*/
#define Crit 2
typedef double float5[3];
typedef int nreftype[900][900];
typedef int* reftype[900][900];

int main(int argc,char**argv)

{
   FILE *f;
   float5 **data;
   double **x,**y,Chi,SN,Shmin,Shmax,cp;
   float r,BestR;
   int *n,**mark,fld,i,j,k,*Best;
   int x0,x1,y0,y1,xx,yy,q;
   char str[161];
   nreftype *nref;
   reftype *ref;

   if (argc!=8) {
      printf("usage: %s <in1> <in2> <output> <chi> <S/N> <min sharp> <max sharp>\n",argv[0]);
      return 1;
   }
   Chi=atof(argv[4]);
   SN=atof(argv[5]);
   Shmin=atof(argv[6]);
   Shmax=atof(argv[7]);
   x=(double**)calloc(sizeof(double*),2);
   y=(double**)calloc(sizeof(double*),2);
   data=(float5**)calloc(sizeof(float5*),2);
   n=(int*)calloc(sizeof(int),2);
   nref=(nreftype*)calloc(sizeof(nreftype),2);
   ref=(reftype*)calloc(sizeof(reftype),2);
   mark=(int**)calloc(sizeof(int*),2);
   Best=(int*)calloc(sizeof(int),2);
   if (data==NULL || x==NULL || y==NULL || n==NULL || nref==NULL || ref==NULL || mark==NULL || Best==NULL) {
      printf("Memory error\n");
   }
   for (fld=0;fld<4;fld++) {
      for (i=0;i<2;i++) {
	 f=fopen(argv[1+i],"r");
	 if (f==NULL) {
	    printf("Could not open input file %s\n",argv[1+i]);
	    return 1;
	 }
	 n[i]=0;
	 fgets(str,160,f);
	 while (!feof(f)) {
	    if (atoi(str)==fld && atof(str+46)<=Chi && atof(str+55)>=SN && atof(str+63)>=Shmin && atof(str+63)<=Shmax && atoi(str+70)<4) {
	       n[i]++;
	       j=atoi(str+2)+50;
	       k=atoi(str+9)+50;
	       if (j>=0 && k>=0 && j<900 && k<900) nref[i][j][k]++;
	    }
	    fgets(str,160,f);
	 }
	 fclose(f);
	 for (j=0;j<900;j++) for (k=0;k<900;k++) if (nref[i][j][k]) {
	    ref[i][j][k]=(int*)calloc(sizeof(int),nref[i][j][k]);
	    nref[i][j][k]=0;
	 }
	 data[i]=(float5*)calloc(sizeof(float5),n[i]+1);
	 x[i]=(double*)calloc(sizeof(double),n[i]+1);
	 y[i]=(double*)calloc(sizeof(double),n[i]+1);
	 mark[i]=(int*)calloc(sizeof(int),n[i]+1);
	 if ((data[i]==NULL) || (x[i]==NULL) || (y[i]==NULL) || (mark[i]==NULL)) {
	    printf("Memory error\n");
	    return 1;
	 }
	 f=fopen(argv[1+i],"r");
	 fgets(str,160,f);
	 j=0;
	 n[i]=0;
	 while (!feof(f)) {
	    if (atoi(str)==fld && atof(str+46)<=Chi && atof(str+55)>=SN && atof(str+63)>=Shmin && atof(str+63)<=Shmax && atoi(str+70)<4) {
	       x[i][j]=atof(str+2)+50;
	       y[i][j]=atof(str+9)+50;
	       if (x[i][j]>=0 && y[i][j]>=0 && x[i][j]<900 && y[i][j]<900) {
		  data[i][j][0]=atof(str+32);
		  data[i][j][1]=atof(str+39);
		  data[i][j][2]=atof(str+62);
		  mark[i][j]=0;
		  ref[i][(int)x[i][j]][(int)y[i][j]][nref[i][(int)x[i][j]][(int)y[i][j]]]=j;
		  nref[i][(int)x[i][j]][(int)y[i][j]]++;
		  n[i]++;
		  j++;
	       }
	    }
	    fgets(str,160,f);
	 }
	 fclose(f);
      }
      if (!fld) f=fopen(argv[3],"w");
      else f=fopen(argv[3],"a");
      if (f==NULL) {
	 printf("Could not open output files\n");
	 return 1;
      }
      for (i=0;i<n[0];i++) if (x[0][i]>=0 && y[0][i]>=0 && x[0][i]<900 && y[0][i]<900) {
	 Best[0]=i;
	 x0=(int)(x[0][i]-Crit);
	 if (x0<0) x0=0;
	 x1=(int)(x[0][i]+Crit+.99);
	 if (x1>899) x1=899;
	 y0=(int)(y[0][i]-Crit);
	 if (y0<0) y0=0;
	 y1=(int)(y[0][i]+Crit+.99);
	 if (y1>899) y1=899;
	 BestR=1.e7;
	 Best[1]=-1;
	 for (xx=x0;xx<=x1;xx++) for (yy=y0;yy<=y1;yy++) for (j=0;j<nref[1][xx][yy];j++) if (!mark[1][q=ref[1][xx][yy][j]]) {
	    if ((fabs(x[0][i]-x[1][q])<=Crit) && (fabs(y[0][i]-y[1][q])<=Crit)) {
	       r=sqrt((x[0][i]-x[1][q])*(x[0][i]-x[1][q])+(y[0][i]-y[1][q])*(y[0][i]-y[1][q]));
	       if ((r<=Crit) && (r<BestR)) {
		  Best[1]=q;
		  BestR=r;
	       }
	    }
	 }
	 if (Best[1]>=0) {
	    cp=0;
	    for (j=0;j<2;j++) cp+=x[j][Best[j]]*.5;
	    fprintf(f,"%d %6.2f ",fld,cp-50);
	    cp=0;
	    for (j=0;j<2;j++) cp+=y[j][Best[j]]*.5;
	    fprintf(f,"%6.2f ",cp-50);
	    fprintf(f,"%6.3f %6.3f %6.3f %6.3f %e %e\n",data[0][Best[0]][0],data[0][Best[0]][1],data[1][Best[1]][0],data[1][Best[1]][1],data[0][Best[0]][2],data[1][Best[1]][2]);
	    mark[1][Best[1]]=1;
	 }
      }
      fclose(f);
      for (i=0;i<2;i++) {
	 free(data[i]);
	 free(x[i]);
	 free(y[i]);
	 free(mark[i]);
      }
   }
   return 0;
}
