#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "filters.h"

/*#define Rmin 1.*/
#define Crit 2
typedef double float5[8];
typedef int nreftype[900][900];
typedef int* reftype[900][900];

int main(int argc,char**argv)

{
   FILE *f;
   float5 **data,bestdata;
   double **x,**y,Chi,SN,Shmin,Shmax,cp;
   float r,BestR,MaxM,MinM;
   int *n,**mark,fld,i,j,k,*Best,TBest,NN,II,JJ,Nmin;
   int x0,x1,y0,y1,xx,yy,q,F=0;
   char str[161];
   nreftype *nref;
   reftype *ref;

   if (argc<9 || argc%3!=1) {
      printf("usage: %s <in1> <minmag1> <maxmag1> ... <inN> <minmagN> <maxmagN> <output> <Nmin> <chi> <S/N> <min Sh> <max Sh>\n",argv[0]);
      return 1;
   }
   NN=(argc-7)/3;
   Nmin=atoi(argv[argc-5]);
   Chi=atof(argv[argc-4]);
   SN=atof(argv[argc-3]);
   Shmin=atof(argv[argc-2]);
   Shmax=atof(argv[argc-1]);
   x=(double**)calloc(sizeof(double*),NN);
   y=(double**)calloc(sizeof(double*),NN);
   data=(float5**)calloc(sizeof(float5*),NN);
   n=(int*)calloc(sizeof(int),NN);
   nref=(nreftype*)calloc(sizeof(nreftype),NN);
   ref=(reftype*)calloc(sizeof(reftype),NN);
   mark=(int**)calloc(sizeof(int*),NN);
   Best=(int*)calloc(sizeof(int),NN);
   if (data==NULL || x==NULL || y==NULL || n==NULL || nref==NULL || ref==NULL || mark==NULL || Best==NULL) {
      printf("Memory error\n");
   }
   initfilters();
   for (i=0;i<NN;i++) {
      char *ptr;
      for (ptr=argv[1+i*3]+strlen(argv[1+i*3])-2;ptr>argv[1+i*3] && *ptr!='.';ptr--);
      if (*ptr=='.') {
	 int filt;
	 ptr++;
	 for (filt=0;filt<NFILTERS && strcmp(ptr,filters[filt].suffix);filt++);
	 if (filt==NFILTERS) {
	    printf("Illegal filter suffix \"%s\"\n",ptr);
	    exit(0);
	 }
	 if (i==0) F=filt;
	 else if (F!=filt) {
	    printf("Photometry lists are not from the same filter\n");
	    exit(0);
	 }
      }
      else {
	 printf("Illegal filename %s: no filter suffix found\n",argv[1+i*3]);
	 exit(0);
      }
   }
   for (fld=0;fld<4;fld++) {
      for (i=0;i<NN;i++) {
	 f=fopen(argv[1+i*3],"r");
	 if (f==NULL) {
	    printf("Could not open input file %s\n",argv[1+i*3]);
	    return 1;
	 }
	 n[i]=0;
	 fgets(str,160,f);
	 while (!feof(f)) {
	    if (atoi(str)==fld && atof(str+46)<=Chi && atof(str+55)>=SN && atof(str+63)>=Shmin && atof(str+63)<=Shmax && atoi(str+70)<4) {
	       n[i]++;
	       j=atoi(str+2)+50;
	       k=atoi(str+9)+50;
	       if (j>=0 && k>=0 && j<900 && k<900) nref[i][j][k]++;
	    }
	    fgets(str,160,f);
	 }
	 fclose(f);
	 for (j=0;j<900;j++) for (k=0;k<900;k++) if (nref[i][j][k]) {
	    ref[i][j][k]=(int*)calloc(sizeof(int),nref[i][j][k]);
	    nref[i][j][k]=0;
	 }
	 data[i]=(float5*)calloc(sizeof(float5),n[i]+1);
	 x[i]=(double*)calloc(sizeof(double),n[i]+1);
	 y[i]=(double*)calloc(sizeof(double),n[i]+1);
	 mark[i]=(int*)calloc(sizeof(int),n[i]+1);
	 if ((data[i]==NULL) || (x[i]==NULL) || (y[i]==NULL) || (mark[i]==NULL)) {
	    printf("Memory error\n");
	    return 1;
	 }
	 MinM=atof(argv[2+i*3]);
	 MaxM=atof(argv[3+i*3]);
	 f=fopen(argv[1+i*3],"r");
	 fgets(str,160,f);
	 j=0;
	 n[i]=0;
	 while (!feof(f)) {
	    if (atoi(str)==fld && atof(str+46)<=Chi && atof(str+55)>=SN && atof(str+63)>=Shmin && atof(str+63)<=Shmax && atoi(str+70)<4) {
	       x[i][j]=atof(str+2)+50;
	       y[i][j]=atof(str+9)+50;
	       if (x[i][j]>=0 && y[i][j]>=0 && x[i][j]<900 && y[i][j]<900) {
		  data[i][j][0]=atof(str+16);
		  data[i][j][1]=atof(str+25);
		  data[i][j][2]=atof(str+32);
		  data[i][j][3]=atof(str+39);
		  data[i][j][4]=atof(str+46);
		  data[i][j][5]=atof(str+55);
		  data[i][j][6]=atof(str+63);
		  data[i][j][7]=atof(str+70);
		  if (data[i][j][5]>0.2) data[i][j][5]=data[i][j][0]/data[i][j][5];
		  else data[i][j][5]=data[i][j][0]*5;
		  mark[i][j]=0;
		  ref[i][(int)x[i][j]][(int)y[i][j]][nref[i][(int)x[i][j]][(int)y[i][j]]]=j;
		  nref[i][(int)x[i][j]][(int)y[i][j]]++;
		  n[i]++;
		  j++;
	       }
	    }
	    fgets(str,160,f);
	 }
	 fclose(f);
      }
      if (!fld) f=fopen(argv[1+NN*3],"w");
      else f=fopen(argv[1+NN*3],"a");
      if (f==NULL) {
	 printf("Could not open output files\n");
	 return 1;
      }
      for (II=0;II<=NN-Nmin;II++) for (i=0;i<n[II];i++) if (!mark[II][i] && x[II][i]>=0 && y[II][i]>=0 && x[II][i]<900 && y[II][i]<900) {
	 for (JJ=0;JJ<NN;JJ++) Best[JJ]=-1;
	 Best[II]=i;
	 TBest=1;
	 x0=(int)(x[II][i]-Crit);
	 if (x0<0) x0=0;
	 x1=(int)(x[II][i]+Crit+.99);
	 if (x1>899) x1=899;
	 y0=(int)(y[II][i]-Crit);
	 if (y0<0) y0=0;
	 y1=(int)(y[II][i]+Crit+.99);
	 if (y1>899) y1=899;
	 for (JJ=1+II;JJ<NN;JJ++) {
	    BestR=1.e7;
	    for (xx=x0;xx<=x1;xx++) for (yy=y0;yy<=y1;yy++) for (j=0;j<nref[JJ][xx][yy];j++) if (!mark[JJ][q=ref[JJ][xx][yy][j]]) {
	       if ((fabs(x[II][i]-x[JJ][q])<=Crit) && (fabs(y[II][i]-y[JJ][q])<=Crit)) {
		  r=sqrt((x[II][i]-x[JJ][q])*(x[II][i]-x[JJ][q])+(y[II][i]-y[JJ][q])*(y[II][i]-y[JJ][q]));
		  cp=r+fabs(data[II][i][2]-data[JJ][q][2]);
		  if ((cp<=Crit) && (cp<BestR)) {
		     Best[JJ]=q;
		     BestR=cp;
		  }
	       }
	    }
	    if (Best[JJ]>=0) TBest++;
	 }
         if (TBest>=Nmin) {
	    cp=0;
	    for (j=0;j<NN;j++) if (Best[j]>=0) cp+=x[j][Best[j]];
	    fprintf(f,"%d %6.2f ",fld,cp/TBest-50);
	    cp=0;
	    for (j=0;j<NN;j++) if (Best[j]>=0) cp+=y[j][Best[j]];
	    fprintf(f,"%6.2f ",cp/TBest-50);
	    for (k=0;k<8;k++) {
	       cp=0;
	       if (k==7) bestdata[k]=5;
	       else bestdata[k]=0;
	       for (j=0;j<NN;j++) if (Best[j]>=0) switch(k) {
	       case 0:case 1: case 2:case 6:
		  bestdata[k]+=data[j][Best[j]][k]/data[j][Best[j]][3];
		  cp+=1./data[j][Best[j]][3];
		  break;
	       case 3:
		  bestdata[k]+=1./data[j][Best[j]][3];
		  break;
	       case 4:
		  bestdata[k]+=data[j][Best[j]][k]*data[j][Best[j]][k]/data[j][Best[j]][3];
		  cp+=1./data[j][Best[j]][3];
		  break;
	       case 5:
		  bestdata[k]+=data[j][Best[j]][k]*data[j][Best[j]][k]/data[j][Best[j]][3]/data[j][Best[j]][3];
		  cp+=1./data[j][Best[j]][3];
		  break;
	       case 7:
		  if (bestdata[k]>data[j][Best[j]][k]) bestdata[k]=data[j][Best[j]][k];
		  break;
	       }
	       if (k==0) bestdata[k]*=TBest/cp;
	       else if (k<3 || k==6) bestdata[k]/=cp;
	       else if (k==3) bestdata[k]=1./bestdata[k];
	       else if (k==4) bestdata[k]=sqrt(bestdata[k]/cp);
	       else if (k==5) bestdata[k]=sqrt(bestdata[k])*TBest/cp;
	    }
	    if (bestdata[5]>bestdata[0]/99999.L) bestdata[5]=bestdata[0]/bestdata[5];
	    else bestdata[5]=99999.L;
	    if (bestdata[0]<999999.5) fprintf(f,"%8.1f",bestdata[0]);
	    else fprintf(f,"%8.2e",bestdata[0]);
	    fprintf(f," %6.2f %6.3f %6.3f %8.4f %7.1f %6.3f %d\n",bestdata[1],bestdata[2],bestdata[3],bestdata[4],bestdata[5],bestdata[6],(int)(bestdata[7]+.5));
	    for (j=II;j<NN;j++) if (Best[j]>=0) mark[j][Best[j]]=1;
	 }
      }
      fclose(f);
      for (i=0;i<NN;i++) {
	 free(data[i]);
	 free(x[i]);
	 free(y[i]);
	 free(mark[i]);
      }
   }
   return 0;
}
