#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc,char**argv) {
   FILE *f;
   long prof[1000][3];
   char str[80];
   int i,N,BIN,fld,filt;
   double MMAX,CX,CY;
   double x,y,a;

   if (argc!=10) {
      printf("Usage: %s <phot> <artstars> <filter> <max mag> <chip> <Xcenter> <Ycenter> <nbins> <bin size>\n",*argv);
      exit(0);
   }
   filt=atoi(argv[3]);
   if (filt<1 || filt>2) {
      printf("Filter must be 1 or 2\n");
      exit(0);
   }
   MMAX=atof(argv[4]);
   fld=atoi(argv[5]);
   CX=atof(argv[6]);
   CY=atof(argv[7]);
   N=atoi(argv[8]);
   BIN=atoi(argv[9]);
   for (i=0;i<N;i++) prof[i][0]=prof[i][1]=prof[i][2]=0;
   if ((f=fopen(argv[1],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[1]);
      exit(0);
   }
   fgets(str,80,f);
   while (!feof(f)) {
      if (atoi(str+1) && atoi(str)==fld && atof(str+32)<=MMAX) {
	 x=atof(str+2)-CX;
	 y=atof(str+9)-CY;
	 i=(int)(sqrt(x*x+y*y)/BIN);
         if (i<N) prof[i][0]++;
      }
      fgets(str,80,f);
   }
   fclose(f);
   if ((f=fopen(argv[2],"r"))==NULL) {
      printf("Cannot open file %s\n",argv[2]);
      exit(0);
   }
   fgets(str,80,f);
   while (!feof(f)) {
      if (atoi(str+1) && atof(str+16)<=MMAX) {
	 x=atof(str+2)-CX;
	 y=atof(str+9)-CY;
	 i=(int)(sqrt(x*x+y*y)/BIN);
	 if (i<N) {
	    prof[i][1]++;
	    if (filt==1 && atof(str+23)<50) prof[i][2]++;
	    else if (filt==2 && atof(str+37)<50) prof[i][2]++;
	 }
      }
      fgets(str,80,f);
   }
   fclose(f);
   printf(" r0  r1  Nobs Nfake  Nrec  complt       corrected          density\n");
   for (i=0;i<N;i++) {
      if (prof[i][2]) {
	 x=(double)prof[i][2]/prof[i][1];
	 y=(prof[i][2]>prof[i][1]*.5)?prof[i][1]-prof[i][2]:prof[i][2];
	 if (!y) y=1;
	 y=sqrt(y)/prof[i][1];
	 y=(prof[i][0])?prof[i][0]/x*sqrt(1./prof[i][0]+y):1./x*sqrt(1+y);
	 a=M_PI*((i+1)*(i+1)-i*i)*BIN*BIN;
	 printf("%3d %3d %5ld %5ld %5ld %7.5f %9.3f %8.3f %9.6f %8.6f\n",i*BIN,(i+1)*BIN,prof[i][0],prof[i][1],prof[i][2],x,prof[i][0]/x,y,prof[i][0]/x/a,y/a);
      }
      else if (prof[i][1]) {
	 printf("%3d %3d %5ld %5ld %5ld %7.5f %9.3f %8.3f %9.6f %8.6f\n",i*BIN,(i+1)*BIN,prof[i][0],prof[i][1],prof[i][2],0.,-1.,-1.,-1.,-1.);
      }
      else {
	 printf("%3d %3d %5ld %5ld %5ld %7.5f %9.3f %8.3f %9.6f %8.6f\n",i*BIN,(i+1)*BIN,prof[i][0],prof[i][1],prof[i][2],-1.,-1.,-1.,-1.,-1.);
      }
   }
   return 0;
}
