#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#ifdef LINUX
#include "../linux.h"
#else
#include "../sun.h"
#endif

char filt[20];
int rpsf[4],sub[4];
double dQE,sigma[2];

void merr(void) {
   printf("Mem error\n");
   exit(0);
}

void ferr(FILE *f,char *str) {
   printf("%s\n",str);
   fclose(f);
   exit(1);
}

void smear(int f,float psf[200][200]) {
   float new[200][200];
   int x,y,xx,yy;
   static int lastf=-1,dmax;
   static float kernel[101][101];
   double sum=0,isig2;

   if (f>lastf && lastf<1) {
      for (x=-50;x<=50;x++) for (y=-50;y<=50;y++) kernel[x+50][y+50]=0;
      if ((f && sigma[1]==0) || (!f && sigma[0]==0)) {
	 kernel[50][50]=1.;
	 dmax=0;
      }
      else {
	 if (f) {
	    isig2=24.805/(sigma[1]*sigma[1])*0.5;
	    dmax=(int)(sigma[1]/4.9805*4.+1);
	 }
	 else {
	    isig2=20.739/(sigma[0]*sigma[0])*0.5;
	    dmax=(int)(sigma[0]/4.554*4.+1);
	 }
	 if (dmax>50) dmax=50;
	 for (x=-dmax;x<=dmax;x++) for (y=-dmax;y<=dmax;y++) sum+=(kernel[x+50][y+50]=exp(-(x*x+y*y)*isig2));
	 for (x=-dmax;x<=dmax;x++) for (y=-dmax;y<=dmax;y++) kernel[x+50][y+50]/=sum;
      }
      lastf=f;
   }
   for (x=0;x<200;x++) for (y=0;y<200;y++) {
      new[x][y]=0;
      for (xx=-dmax;xx<=dmax;xx++) for (yy=-dmax;yy<=dmax;yy++) if (x+xx>=0 && x+xx<200 && y+yy>=0 && y+yy<200) new[x][y]+=psf[x+xx][y+yy]*kernel[xx+50][yy+50];
   }
   for (x=0;x<200;x++) for (y=0;y<200;y++) psf[x][y]=new[x][y];
}

void getpsf(void) {
   int f,x,y,z,rad,px,py;
   int mode=1,x1,y1,x2,y2,l,dx,dy,dx1,dy1;
   long tpsf[200][200];
   FILE *pf,*of;
   char fn[80],cn[4][4]={"pc1","wf2","wf3","wf4"},str[81];
   float tpsf2[200][200],**psf;
   double zero=0,scale=1,norm,m;
;

   sprintf(fn,"%s/psfs/%s.%d.%d.psf",BASEDIR,filt,rpsf[0],sub[0]);
   if ((of=fopen(fn,"wb"))==NULL) {
      printf("Cannot write %s\n",fn);
      exit(1);
   }
   for (f=0;f<4;f++) {
      psf=(float**)calloc(2*rpsf[f]+1,sizeof(float*));
      if (!psf) merr();
      psf+=rpsf[f];
      for (z=-rpsf[f];z<=rpsf[f];z++) {
	 psf[z]=(float*)calloc(2*rpsf[f]+1,sizeof(float));
	 if (!psf[z]) merr();
	 psf[z]+=rpsf[f];
      }
      rad=(sub[f]+2)/2;
      for (px=0;px<8;px++) for (py=0;py<8;py++) {
	 sprintf(fn,"%s.%s%d%d.fit",cn[f],filt,(px*8+py)/10,(px*8+py)%10);
	 if ((pf=fopen(fn,"rb"))==NULL) {
	    printf("File error: %s\n",fn);
	    exit(0);
	 }
	 printf("Processing %s: %d^2x%d^2\n",fn,rad*2+1,rpsf[f]*2+1);
	 fgets(str,81,pf);
	 l=1;
	 while ((!feof(pf)) && mode) {
	    if (!strncmp(str,"END     ",8)) mode=0;
	    else if ((!strncmp(str,"SIMPLE  =",9)) && (str[29]!='T')) ferr(pf,"Illegal format type");
	    else if ((!strncmp(str,"BITPIX  =",9)) && (strncmp(str+27," 32",3))) ferr(pf,"Illegal bits per pixel");
	    else if ((!strncmp(str,"NAXIS   =",9)) && (strncmp(str+27,"  2",3))) ferr(pf,"Illegal number of axes");
	    else if ((!strncmp(str,"NAXIS1  =",9)) && (strncmp(str+27,"200",3))) ferr(pf,"Illegal axis size");
	    else if ((!strncmp(str,"NAXIS2  =",9)) && (strncmp(str+27,"200",3))) ferr(pf,"Illegal axis size");
	    else if (!strncmp(str,"BZERO   =",9)) zero=atof(str+10);
	    else if (!strncmp(str,"BSCALE  =",9)) scale=atof(str+10);
	    str[40]=0;
	    fgets(str,81,pf);
	    l++;
	 }
	 while (l<36) {
	    for (x1=0;x1<80;x1++) getc(pf);
	    l++;
	 }
	 ffread(tpsf,200*200,4,pf);
	 fclose(pf);
	 norm=0;
	 for (x=0;x<200;x++) for (y=0;y<200;y++) tpsf2[x][y]=(float)tpsf[x][y]*scale+zero;
	 smear(f,tpsf2);
	 for (x=0;x<200;x++) for (y=0;y<200;y++) norm+=tpsf2[x][y];
	 for (x=-rad;x<=rad;x++) for (y=-rad;y<=rad;y++) {
	    for (x1=-rpsf[f];x1<=rpsf[f];x1++) for (y1=-rpsf[f];y1<=rpsf[f];y1++) psf[x1][y1]=0;
	    for (x1=0;x1<200;x1++) for (y1=0;y1<200;y1++) {
	       dx=(x1-100)+x*(10/sub[0]);
	       dy=(y1-100)+y*(10/sub[0]);
	       if (!f) {
		  x2=(dx+5+10000)/10-1000;
		  y2=(dy+5+10000)/10-1000;
		  dx-=x2*10;
		  dx1=dx+1;
		  dy-=y2*10;
		  dy1=dy+1;
		  m=1+dQE*(50-dx1*dx1*dx1+dx*dx*dx-dy1*dy1*dy1+dy*dy*dy)/100.;
	       }
	       else {
		  x2=(dx+10+20000)/20-1000;
		  y2=(dy+10+20000)/20-1000;
		  dx-=x2*20;
		  dx1=dx+1;
		  dy-=y2*20;
		  dy1=dy+1;
		  m=1+dQE*(200-dx1*dx1*dx1+dx*dx*dx-dy1*dy1*dy1+dy*dy*dy)/400.;
	       }
	       if (abs(x2)<=rpsf[f] && abs(y2)<=rpsf[f]) psf[x2][y2]+=tpsf2[x1][y1]/norm*m;
	    }
	    for (x1=-rpsf[f];x1<=rpsf[f];x1++) ffwrite(psf[x1]-rpsf[f],2*rpsf[f]+1,sizeof(float),of);
	 }
      }
      for (z=-rpsf[f];z<=rpsf[f];z++) free(psf[z]-rpsf[f]);
      free(psf-rpsf[f]);
   }
   fclose(of);
}

int main(int argc,char**argv) {
   if (argc!=7) {
      printf("Usage: %s <filter> <rpsf> <subsamp> <dQE> <PC spread> <WFC spread>\n",*argv);
      return 1;
   }
   strcpy(filt,argv[1]);
   rpsf[0]=atoi(argv[2]);
   if (rpsf[0]<1 || rpsf[0]>6) {
      printf("Illegal rpsf\n");
      return 1;
   }
   rpsf[1]=rpsf[2]=rpsf[3]=(rpsf[0]*2+1)/3;
   sub[0]=atoi(argv[3]);
   if (sub[0]!=1 && sub[0]!=2 && sub[0]!=5 && sub[0]!=10) {
      printf("Illegal subsampling\n");
      return 1;
   }
   dQE=atof(argv[4]);
   if (dQE>1 || dQE<0) {
      printf("Illegal dQE\n");
      return 1;
   }
   sigma[0]=atof(argv[5]);
   sigma[1]=atof(argv[5]);
   if (sigma[0]<0 || sigma[1]<0) {
      printf("Illegal sigma\n");
      return 1;
   }
   sub[1]=sub[2]=sub[3]=sub[0]*2;
   getpsf();
   return 0;
}
