#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <math.h>
#include "../filters.h"

int main(int argc,char **argv) {
   char pstr[321];
   int fld,filt;
   FILE *f;

   if (argc!=2) {
      printf("Usage: %s <filter>\n",argv[0]);
      exit(0);
   }
   initfilters();
   for (filt=0;filt<NFILTERS && strcmp(argv[1],filters[filt].name);filt++);
   if (filt>=NFILTERS) {
      printf("Filter \"%s\" not in filters.dat\n",argv[1]);
      exit(0);
   }
   mkdir(argv[1],00755);
   for (fld=0;fld<4;fld++) {
      if ((f=fopen("testpar","w"))==NULL) {
	 printf("Cannot open testpar\n");
	 exit(0);
      }
      if (fld) fprintf(f,"5\n%d\n",fld+1);
      else fprintf(f,"6\n");
      fprintf(f,"@coords\n%s\n1\n10\n1.0\nY\n",argv[1]);
      if (fld) fprintf(f,"20\nF\nwf%d.%s",fld+1,filters[filt].suffix);
      else fprintf(f,"10\nF\npc1.%s",filters[filt].suffix);
      fclose(f);
      if (!fld) sprintf(pstr,"%s/tiny1 %s/pc1.par jitter=8.616 > tiny1log < testpar",TTDIR,argv[1]);
      else sprintf(pstr,"%s/tiny1 %s/wf%d.par jitter=26.312 >> tiny1log < testpar",TTDIR,argv[1],fld+1);
      if ((f=popen(pstr,"w"))!=NULL) pclose(f);
      else printf("Cannot run script %d\n",fld+1);
   }
   unlink("testpar");
   sprintf(pstr,"%s/makepsf",argv[1]);
   if ((f=fopen(pstr,"w"))==NULL) {
      printf("Cannot open %s\n",pstr);
      exit(0);
   }
   fprintf(f,"#! /bin/csh\n");
   fprintf(f,"rm tinylog ; touch tinylog\n");
   fprintf(f,"nice +19 %s/tiny2 pc1.par >> tinylog\n",TTDIR);
   fprintf(f,"nice +19 %s/tiny2 wf2.par >> tinylog\n",TTDIR);
   fprintf(f,"nice +19 %s/tiny2 wf3.par >> tinylog\n",TTDIR);
   fprintf(f,"nice +19 %s/tiny2 wf4.par >> tinylog\n",TTDIR);
   fprintf(f,"nice +19 %s/psfs/makepsf %s 6 5 0.07 13 15\n",BASEDIR,filters[filt].suffix);
   fclose(f);
   chmod(pstr,00755);
   return 0;
}
