#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifdef LINUX
#include "../linux.h"
#else
#include "../sun.h"
#endif
#include "../filters.h"

int main(int argc,char**argv) {
   int flt,f,x,y,fx,fy,i,j,k,l,m,n;
   int sub[4]={5,10,10,10};
   int rpsf[4]={6,4,4,4};
   int r[4]={3,6,6,6};
   FILE *fpsf;
   char str[161];
   float *psf;

   if (argc!=7) {
      printf("Usage: %s <filt> <chp> <X/100> <Y/100> <dX> <dY>\n",*argv);
      return -1;
   }
   initfilters();
   flt=findfilt(argv[1]);
   f=atoi(argv[2]);
   if (f<0 || f>3) {
      printf("Chip must be 0-3\n");
      return -1;
   }
   x=atoi(argv[3]);
   y=atoi(argv[4]);
   if (x<0 || x>7 || y<0 || y>7) {
      printf("X and Y positions must be 0-7\n");
      return -1;
   }
   fx=atoi(argv[6]);
   fy=atoi(argv[5]);
   if (fx<-r[f] || fx>r[f] || fy<-r[f] || fy>r[f]) {
      printf("dX and dY must be -%d to %d\n",r[f],r[f]);
      return -1;
   }
   sprintf(str,"%s/psfs/%s.%d.%d.psf",BASEDIR,filters[flt].suffix,rpsf[0],sub[0]);
   if ((fpsf=fopen(str,"rb"))==NULL) {
      printf("Cannot open %s\n",str);
      return -1;
   }
   psf=(float*)calloc(sizeof(float),rpsf[0]*2+1);
   if (!psf) {
      printf("Memory allocation error\n");
      return -1;
   }
   psf+=rpsf[0];
   for (i=0;i<f;i++) for (j=0;j<8;j++) for (k=0;k<8;k++) for (l=-r[i];l<=r[i];l++) for (m=-r[i];m<=r[i];m++) for (n=-rpsf[i];n<=rpsf[i];n++) fread(psf-rpsf[i],4,2*rpsf[i]+1,fpsf);
   for (j=0;j<x;j++) for (k=0;k<8;k++) for (l=-r[f];l<=r[f];l++) for (m=-r[f];m<=r[f];m++) for (n=-rpsf[f];n<=rpsf[f];n++) fread(psf-rpsf[f],4,2*rpsf[f]+1,fpsf);
   for (k=0;k<y;k++) for (l=-r[f];l<=r[f];l++) for (m=-r[f];m<=r[f];m++) for (n=-rpsf[f];n<=rpsf[f];n++) fread(psf-rpsf[f],4,2*rpsf[f]+1,fpsf);
   for (l=-r[f];l<fy;l++) for (m=-r[f];m<=r[f];m++) for (n=-rpsf[f];n<=rpsf[f];n++) fread(psf-rpsf[f],4,2*rpsf[f]+1,fpsf);
   for (m=-r[f];m<fx;m++) for (n=-rpsf[f];n<=rpsf[f];n++) fread(psf-rpsf[f],4,2*rpsf[f]+1,fpsf);
   for (n=-rpsf[f];n<=rpsf[f];n++) {
      ffread(psf-rpsf[f],4,2*rpsf[f]+1,fpsf);
      for (j=-rpsf[f];j<=rpsf[f];j++) printf("%5d ",(int)(psf[j]*100000+0.5));
      printf("\n");
   }
   fclose(fpsf);
   return 0;
}
